using FluentValidation;
using CMSMicroservice.Protobuf.Protos.UserAddress;
namespace CMSMicroservice.Protobuf.Validator.UserAddress;

public class CreateNewUserAddressRequestValidator : AbstractValidator<CreateNewUserAddressRequest>
{
    public CreateNewUserAddressRequestValidator()
    {
        RuleFor(model => model.UserId)
            .NotNull();
        RuleFor(model => model.Title)
            .NotEmpty();
        RuleFor(model => model.Address)
            .NotEmpty();
        RuleFor(model => model.PostalCode)
            .NotEmpty();
        RuleFor(model => model.IsDefault)
            .NotNull();
        RuleFor(model => model.CityId)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<CreateNewUserAddressRequest>.CreateWithOptions((CreateNewUserAddressRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
